/*
**  Two Men Result Layout
**  JavaScript engine
*/


/* Import needed packages */
importPackage( java.util );

/* Static variable defines */
var PluginType_Track = 1;
var PluginType_Route = 2;
var PluginType_Both = 3;
var PluginType_Http = 4;

var PluginOutput_Html = 1;
var PluginOutput_List = 2;


/* Get short presentation of plugin's name */
function getName()
{
  return "Two Men Result Layout";
}

/* Get plugin's version number */
function getVersion()
{
  return 1.0;
}

/* Get long presentation of plugin's name */
function getFullName()
{
  return getName() + " v" + getVersion();
}

/* Default implementation of method toString */
function toString()
{
  return getFullName();
}

/* Get plugin type */
function getType()
{
  return PluginType_Track;
  //return PluginType_Route;
  //return PluginType_Both;
  //return PluginType_Http;
}

/* Get plugin output format */
function getOutputFormat()
{
  //return PluginOutput_List;
  return PluginOutput_Html;
}

/* Get possible options displayed at plugin window combobox */
function getOptionGroup()
{
  return Arrays.asList( [ 'Group By 10', 'Group By 100', 'Group By 1000' ] );
}

/* Get list column names when using PluginOutput_List */
function getColumns()
{
  return Arrays.asList( [ ] );
}

/* Get information about data what we need with next invoke (fireDataUpdate) */
/* See Plugin API for available methods */
function getInvokeWith()
{
  return Arrays.asList( [ 'getRoundsPointsAsLaps', 'getRoundsPointsAsTime' ] );
}

/* Invoke event when competitor is selected in list when using PluginOutput_List */
function fireCompetitorSelection( competitors )
{
  //
}

function StringToTime( string )
{
  var negative = false;
  if( string.charAt( 0 ) == '-' )
    negative = true;

  if( string == null || string == "00:00:00.000" )
    return 0;
  else if( string.match("^([0-2]{1})([0-9]{1})(:)([0-5]{1})([0-9]{1})(:)([0-5]{1})([0-9]{1})(\\.)([0-9]{3})$") ||
           string.match("^\\-([0-2]{1})([0-9]{1})(:)([0-5]{1})([0-9]{1})(:)([0-5]{1})([0-9]{1})(\\.)([0-9]{3})$")
         )
  {
    var pString = string.split(":");
    var sString = pString[2].split("\\.");

    var sum = ( pString[0] * 3600 * 1000 );
    sum += ( pString[1] * 60 * 1000 );
    sum += ( sString[0] * 1000 );
    sum += ( sString[1] * 1 );

    if( negative )
      sum = -sum;

    return sum;
  }
  else
    return 0;
}

function TimeToString( time )
{
  var negative = false;
  if( time < 0 )
  {
    negative = true;
    time = -time;
  }

  var hours = ( time / ( 3600 * 1000 ) );
  var minutes = ( time % ( 3600 * 1000 ) ) / ( 60 * 1000 );
  var seconds = ( ( time % ( 3600 * 1000 ) ) % ( 60 * 1000 ) ) / 1000;
  var sSeconds = ( ( time % ( 3600 * 1000 ) ) % ( 60 * 1000 ) ) % 1000;
  
  var tHours = ( Math.round( Math.floor( hours ) ) ) + "";
  var tMinutes = ( Math.round( Math.floor( minutes ) ) ) + "";
  var tSeconds = ( Math.round( Math.floor( seconds ) ) ) + "";
  var tSSeconds = ( Math.round( Math.floor( sSeconds ) ) ) + "";
  
  if( hours < 10 )
    tHours = "0" + tHours;
  if( minutes < 10 )
    tMinutes = "0" + tMinutes;
  if( seconds < 10 )
    tSeconds = "0" + tSeconds;
  
  if( sSeconds < 10 )
    tSSeconds = "00" + tSSeconds;
  else if( sSeconds < 100 )
    tSSeconds = "0" + tSSeconds;

  return ( ( negative ) ? "-" : "" ) + tHours + ":" + tMinutes + ":" + tSeconds + "." + tSSeconds;
}

function GetGroupFromNumber( number, selectedOptionIndex )
{
  var amount = 100;

  if( selectedOptionIndex == 0 )
    amount = 10;
  else if( selectedOptionIndex == 1 )
    amount = 100;
  else if( selectedOptionIndex == 2 )
    amount = 100;
  else
    return number;

  if( number > amount )
    return number - amount;
  else
    return number;
}

Object.size = function(obj)
{
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

/* Invoke function (data processing itself) */
function fireDataUpdate( invokeData, selectedOptionIndex )
{
  var invokes = invokeData.toArray();
  
  var roundsPointsAsLaps = invokes[ getInvokeWith().indexOf("getRoundsPointsAsLaps") ].toArray();
  var roundsPointsAsTime = invokes[ getInvokeWith().indexOf("getRoundsPointsAsTime") ].toArray();
  
  var html = "";

  html += "<table style=\"width: 100%; font-family: sans-serif;\">\n";

  html += "<tr>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Group</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Number</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Name</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Class</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Additional</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Laps</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Total</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">TC mins</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Lap adjust</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Result</td>";
  html += "<td style=\"border-bottom: 1px solid gray; padding-right: 15px; background-color: #F5F5F5; font-weight: bold;\">Time</td>";
  html += "</tr>\n";

  var results = [];

  for( var i=0; i < roundsPointsAsLaps.length; i++ )
  {
    roundsPointsAsLap = roundsPointsAsLaps[i].toArray();

    var number = roundsPointsAsLap[2]; // [2]: number
    var group = GetGroupFromNumber( number, selectedOptionIndex );

    var x = [];
    var y = [];

    y["name"] = roundsPointsAsLap[0];
    y["class"] = roundsPointsAsLap[4];
    y["additional"] = roundsPointsAsLap[1];
    y["parts"] = roundsPointsAsLap[8];
    y["total"] = roundsPointsAsLap[9];

    y["penalties_laps"] = roundsPointsAsLap[11];
    y["penalties_time"] = roundsPointsAsLap[10];

    x[ number ] = y;

    if( results[ group ] )
      results[ group ][ number ] = y;
    else
      results[ group ] = x;
  }

  for( var i=0; i < roundsPointsAsTime.length; i++ )
  {
    roundsPointsAsTick = roundsPointsAsTime[i].toArray();

    var number = roundsPointsAsTick[2]; // [2]: number
    var group = GetGroupFromNumber( number, selectedOptionIndex );

    results[ group ][ number ]["time"] = roundsPointsAsTick[9];
  }

  for( var group in results )
  {
    var groupTime = 0;
    var groupLaps = 0.0;
    var counter = 1;

    for( var number in results[ group ] )
    {
      groupTime += StringToTime( results[ group ][ number ]["time"] );
      groupLaps += results[ group ][ number ]["total"] * 1;

      var separator = "";
      if( counter == Object.size( results[ group ] ) )
        separator += " style=\"border-bottom: 1px solid silver;\"";

      html += "<tr>\n";

      html += "<td" + separator + ">" + group + "</td>\n";
      html += "<td" + separator + ">" + number + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["name"] + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["class"] + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["additional"] + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["parts"] + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["total"] + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["penalties_time"] + "</td>\n";
      html += "<td" + separator + ">" + results[ group ][ number ]["penalties_laps"] + "</td>\n";

      if( counter == Object.size( results[ group ] ) )
      {
        html += "<td" + separator + ">" + groupLaps + "</td>\n";
        html += "<td" + separator + ">" + TimeToString( groupTime ) + "</td>\n";
      }
      else
      {
        html += "<td" + separator + "></td>\n";
        html += "<td" + separator + "></td>\n";
      }
      html += "</tr>\n";

      counter ++;
    }
  }
  
  return html;
}

